<?php

/**
 * APIStore
 * Class APIStore
 */
class APIStore
{


    /**
     * 获取远程内容
     * @param $url
     * @param null $param
     * @param $key
     * @return mixed
     */
    static public function curl($url, $param, $key)
    {

        //aes
        $aes = new Aes($key);
        $sign = $aes->encrypt(json_encode($param, JSON_UNESCAPED_UNICODE));
        //重新组建数组
        $params['appid'] = $param['appid'];
        $params['sign'] = $sign;

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);

        //如果是https协议
        if (stripos($url, "https://") !== FALSE) {
            /**
             * 如果需要验证证书
             */
            if (SSL_VERIFYPEER) {
                //验证交换证书
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
                //检查SSL证书公用名是否存在，并且是否与提供的主机名匹配
                curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
                //设置实现协议为TLS1.0版本
                curl_setopt($curl, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1);
                //根证书文件路径,相对路径和绝对路径均可,
                //推荐使用绝对路径;为了安全证书文件最好不要和应用代码放在一起;
                //用户请保持更新 使用https接口需要设置该证书文件为可信任根证书，
                //以最大限度满足安全性（使用信任任何证书的方式并不安全）。
                curl_setopt($curl, CURLOPT_CAINFO, dirname(__FILE__) . '/cacert.pem');
            } /**
             * 如果不需要验证证书
             */
            else {
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
                //CURL_SSLVERSION_TLSv1
                curl_setopt($curl, CURLOPT_SSLVERSION, 1);
            }
        }

        //USERAGENT
        curl_setopt($curl, CURLOPT_USERAGENT, 'APIStore');
        //超时时间
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 120);
        curl_setopt($curl, CURLOPT_TIMEOUT, 120);
        //通过POST方式提交
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($params));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        //返回内容
        $callbcak = curl_exec($curl);

        //关闭
        curl_close($curl);
        //解密
        $callbcakdata = $aes->decrypt($callbcak);
        //返回内容
        return json_decode($callbcakdata ? $callbcakdata : $callbcak, true);
    }

}
